% intrp_lagr.m  11-nov-2016
% interpolate n points using n-1 degree polynomial by lagrange method
% n points are in arrays x,y, point to interpolate is X
% in practive you should restric use to middle interval, for example for
% 10 point (9th degree) you should only interpolate between points 5 & 6

function result = intrp_lagr(n,x,y,X)

w=zeros(n,1);
% compute the weights
for i=1:n
  num=1.0;
  den=1.0;
  for j=1:n
    if(i~=j)
      num=num*(X-x(j));
      den=den*(x(i)-x(j));
      end
    end
  w(i)=num/den;
  end

Y=0.0;
for i=1:n
  Y=Y + w(i)*y(i);
  end

result=Y;
